//
//
//    logic.cpp
//
//

#include <iostream>
#include "logic.h"
#include "ui.h"
#include <fstream>
using namespace std;

Limo createLimo (int id, string mark, string model, int year, string capacity, int seatsNr, double hourPrice)
{
   
    Limo limo;
    limo.id               = id;
    limo.mark             = mark;
    limo.model            = model;
    limo.year             = year;
    limo.capacity         = capacity;
    limo.seatsNr          = seatsNr;
    limo.hourPrice        = hourPrice;
    limo.rentedByCustomer = NULL_ID;
    limo.timesRented      = 0;
    limo.moneyEarned      = 0;
    return limo;
}

void readFromFileLimos (Limos& limos)
{
    Limo limo;
    string ignored;
    int amount = 0;
    ifstream fileLimo("limo.txt");
    if (fileLimo.is_open())
    {
         fileLimo >> amount;
         
         getline(fileLimo, ignored);
         if (amount > 0)
         {
         for (int i = 0; i < amount; i++)
         {
            
            int a = 0;
            fileLimo >> limo.id;
            getline(fileLimo, ignored);
            getline(fileLimo, limo.mark);
            getline(fileLimo, limo.model);
            fileLimo >> limo.year;
            getline(fileLimo, ignored);
            getline(fileLimo, limo.capacity);
            fileLimo >> limo.seatsNr; 
            getline(fileLimo, ignored); 
            fileLimo >> limo.hourPrice;
            getline(fileLimo, ignored);
            fileLimo >> limo.rentedByCustomer;
            getline(fileLimo, ignored);
            fileLimo >> limo.timesRented;
            getline(fileLimo, ignored);
            fileLimo >> limo.moneyEarned;
            getline(fileLimo, ignored);
            limos.push_back(limo);
            cout << a;
        }
        }
     }
        else
        {
           exit();
           cout << "Nepavyko atidaryti limuzinu failo\n";
           return;
        }
     fileLimo.close();
}
void readFromFileCustomers (Customers& customers)
{
     Customer customer;
     string ignored;
     int amount = 0;
     ifstream fileCustomer("cust.txt");
     if (fileCustomer.is_open())
     {
         fileCustomer >> amount;
         getline(fileCustomer, ignored);
         if (amount > 0)
         { 
         for (int i = 0; i < amount; i++)
         {
            fileCustomer >> customer.id;
            getline(fileCustomer, ignored);
            getline(fileCustomer, customer.name);
            fileCustomer >> customer.age;
            getline(fileCustomer, ignored);
            fileCustomer >> customer.pCode;
            getline(fileCustomer, ignored);
            fileCustomer >> customer.moneyEarned;   
            customers.push_back(customer);
        }
        }
     }
        else
        {
           exit();
           cout << "Nepavyko atidaryti klientu failo\n";
           return;
        }
     fileCustomer.close();        
   return;
}
     
void writeToFileLimos (Limos& limos)
{
 
     ofstream rezLimo("limo.txt");
     if (rezLimo.is_open())
     {
          rezLimo << limos.size() << "\n";
          for (int i = 0; i < limos.size(); i++)
          {
               Limo limo = limos[i];
               rezLimo << limo.id <<  "\n" << limo.mark << "\n" << limo.model << "\n";
               rezLimo << limo.year << "\n" << limo.capacity << "\n" << limo.seatsNr << "\n";
               rezLimo << limo.hourPrice << "\n" << limo.rentedByCustomer << "\n" << limo.timesRented << "\n";
               rezLimo << limo.moneyEarned << "\n"; 
          }
     }
     rezLimo.close();
}
void writeToFileCustomers (Customers& customers)
{
     ofstream rezCust("cust.txt");
     if (rezCust.is_open())
     {
          rezCust << customers.size() << "\n";
          for (int i = 0; i <customers.size(); i++)
          {    
               Customer customer = customers[i];
               rezCust << customer.id << "\n" << customer.name << "\n" << customer.age << "\n" << customer.pCode << "\n" << customer.moneyEarned << "\n"; 
          }
     }
     rezCust.close();

return;
}

Customer createCustomer (int id, string name, int age, string pCode) 
{
    Customer customer;
    customer.id          = id;
    customer.name        = name;
    customer.age         = age;
    customer.pCode       = pCode;
    customer.moneyEarned = 0;
    return customer;
}

bool isLimoRented (const Limo& limo)
{
    return limo.rentedByCustomer != NULL_ID;
}

double rentLimoAndGetMoneyEarned (Limo& limo, Customer& customer, int dayCount)
{
    double moneyEarned = dayCount * limo.hourPrice;
    limo.rentedByCustomer   = customer.id;
    limo.timesRented++;
    limo.moneyEarned       += moneyEarned;
    customer.moneyEarned   += moneyEarned;
    return moneyEarned;
}

void returnBackRentedLimo (Limo& limo)
{
    limo.rentedByCustomer = NULL_ID;
     
}


    
    
    
