//
//
//    ui.h
//
//

#ifndef  __ui_h
#define  __ui_h

#include <string>
#include "logic.h"

void        exit               ();
bool        wasExitRequested   ();
void        printCommandPrompt ();
std::string inputCommand       ();

void processCommand (Limos& limos, Customers& customers, std::string command);

enum LimoFilter
{
    LIMO_FILTER_ALL,
    LIMO_FILTER_RENTED,
    LIMO_FILTER_NOT_RENTED
};

void printLimo      (const Limo&  limo);
void printCustomer  (const Customer&  customer);
int  printLimosAndReturnCount     (const Limos& limos, LimoFilter limoFilter);
int  printCustomersAndReturnCount (const Customers& customers);


#endif
